#!/bin/bash 
me=$(readlink -f $0)
BASE=$(dirname ${me})

dist=$(lsb_release -s -c)

mkdir -p /etc/ferrari/packages


function uninstall {
	package=$1
	dist=$2
	files=$(/usr/bin/dpkg-deb -c uninstall/${dist}/${package} | awk -F " " '{print $6}' | sed -e s/^.// -)
	for file in  $files; do         #loop
    	if [ ! -d $file ];then      #dont do it if its a directory
        	if [ -e $file ];then    #only continue if file exists
	            #echo "deleting: $file"
    	        /bin/rm -rf $file   #delete, ignore errors
	        fi
	    fi
	done
}
function dpkgEx {
	file=$1
	dist=$2
    	#echo installing ${file}
	if [[ $file =~ .tar$ ]];then
		tar xf ${dist}/$file -C/
	else
		/usr/bin/dpkg-deb -x ${dist}/${file} /
		/usr/bin/dpkg-deb -c ${dist}/${file} > /etc/ferrari/packages/${file}
	fi
}


if [ -d uninstall/${dist} ]; then
    for i in $(ls uninstall/${dist}); do
    #echo uninstalling $i ${dist}
	uninstall $i $dist
    done
fi

if [ -d ${dist} ]; then
    for i in $(ls ${dist}); do   
	if [ ! -d ${dist}/${i} -a -e ${dist}/${i} ];then
	    dpkgEx $i ${dist}
	fi
    done
    
    for i in $(ls ${dist}/*.tar 2>/dev/null); do
	dpkgEx $i .
    done
fi


