-- The good old friend printf() should ONLY be used for quick
-- and dirty TEMPORARY debug output on the console.
VERSION_SPECIFIC_LOAD_DONE=true
if (os.getenv("DOFLUSH") or "1") == "0" then
   DOFLUSH=false
else
   DOFLUSH=true
end

function printf(...)
    local s
    
    --print(_VERSION)

    s = string.format(unpack(arg))
    if (string.sub(s, -1, -1) == "\n") then
    s = string.sub(s, 1, -2)
    end
    print(s)
    if DOFLUSH==true then
       io.flush ()
    end
end

-- This function should always be used for debug output instead
-- of plain old printf() to the console.
function nDebug(name, level, fmt, ...)
    if(dbg==nil) then return end
    if (dbg >= level) then
        local s
        local text

        if fmt ~= nil  and arg ~= nil then
            text = string.format(fmt, unpack(arg))
        else
            text = ""
        end

        s = name .. " (" .. instanceNr .. ") " .. text
        s = string.gsub(s,"\r\n","\n")
        if (string.sub(s, -1, -1) == "\n") then
            s = string.sub(s, 1, -2)
        end

        print(s)
        if DOFLUSH==true then
           io.flush ()
        end
        --local m = {from = "taskInitialName", to = (Partner or "Logging:0"), data = s}
        --cp.msgTx(m)
     end
end

function printDebug(level, fmt, ...)
    if(dbg==nil) then return end
    if (dbg >= level) then
        local s
        local text

                --print(fmt)
        if fmt ~= nil  and arg ~= nil then
            text = string.format(fmt, unpack(arg))
        else
            text = ""
        end

        s = taskInitialName .. " (" .. instanceNr .. ") " .. text
        s = string.gsub(s,"\r\n","\n")
        if (string.sub(s, -1, -1) == "\n") then
            s = string.sub(s, 1, -2)
        end

        print(s)
        if DOFLUSH==true then
           io.flush ()
        end
        --local m = {from = "taskInitialName", to = (Partner or "Logging:0"), data = s}
        --cp.msgTx(m)
     end
end

function sprintf(fmt, ...)
    local text = ""

    if fmt ~= nil  and arg ~= nil then
        text = string.format(fmt, unpack(arg))
    end

    return text
end

-- ====================================================================
-- local debug ========================================================
-- ====================================================================
function jcDebug(id,level, fmt, ...)
    if (dbg >= level) then
        if id=="0" then
            s = taskInitialName .. "(" .. instanceNr .. ") " .. string.format(fmt, unpack(arg))
            s = string.gsub(s,"\r\n","\n")
            if (string.sub(s, -1, -1) == "\n") then
                s = string.sub(s, 1, -2)
            end
        else
            s = GetTaskName() .. ":" .. id .. "(" .. instanceNr .. ") " .. string.format(fmt, unpack(arg))
            s = string.gsub(s,"\r\n","\n")
            if (string.sub(s, -1, -1) == "\n") then
                s = string.sub(s, 1, -2)
            end
        end

        printf("%s\n",s or "NIL")
    end
end

-- ====================================================================
-- local debug ========================================================
-- ====================================================================
function statusDebug(id,level, fmt, ...)
    if (dbg >= level) then
        if id=="0" then
            s = taskInitialName .. "(" .. instanceNr .. ") " string.format(fmt, unpack(arg))
            if (string.sub(s, -1, -1) == "\n") then
                s = string.sub(s, 1, -2)
            end
        else
            s = GetTaskName() .. ":" .. id .. "(" .. instanceNr .. ") " .. string.format(fmt, unpack(arg))
            s = string.gsub(s,"\r\n","\n")
            if (string.sub(s, -1, -1) == "\n") then
                s = string.sub(s, 1, -2)
            end
        end

        printf("%s\n",s or "NIL")
    end
end

do
    local x=0
    local a=1664525
    local c=1013904223

    function randomseed(s)
        x=s
    end

    function random()
        local z = a*x+c
        local m = 4294967295
        if z<m then
            x=z
        else
            x = (z/m)*m
        end
        return tonumber(x)
    end
end
