#!/usr/bin/luaweb
require("json")
require("socket")
require("ssl")
dofile("lua.inc")
dofile("cgi.inc")
dofile("ssl2.inc")


print ("Content-type: application/json\n")
dofile("/data/config.lua")

oldprint=print

function printJs(str)
	oldprint(json.encode(str))
end

debug=arg[1]
function print(str)
	if(debug == "debug")then
		oldprint(str)
	end
end


local info={}

dchannels=config["struct_Box"]["struct_DChannel"]
local bool_VoipEchoCanceller=config["struct_Box"]["bool_VoipEchoCanceller"]
--we can have 14 dchannels
function getHostsFromConfig()
	local newHost={}
	local list={}
	
	if(type(dchannels) == "table")then
	for k,channel in pairs(dchannels) do
--		printJs(tostring(channel["bool_CfgValid"])..channel.string_IlidSlot.."."..channel.string_IlidIndex)
		local channelName=(channel.string_IlidSlot or "").."."..(channel.string_IlidIndex or "")
		info[channelName]=channel["bool_CfgValid"]

		gateParams=channel["struct_GateParams"]
		--print("dchannel: "..k)
		if(channel.bool_CfgValid == true and gateParams ~= nil and channel["struct_GateParams"]["struct_CallProcTable"])then
			callProcTable=channel["struct_GateParams"]["struct_CallProcTable"]
			if(callProcTable ~= nil)then
				if(table.getn(callProcTable) > 1)then
				for i=1, table.getn(callProcTable) do
	--				print(callProcTable[i]["string_sipDefaultGatewayIpPort"])
					if(callProcTable[i].string_Destination == "SIP" and callProcTable[i]["string_sipDefaultGatewayIpPort"] ~= nil and callProcTable[i]["string_sipDefaultGatewayIpAddress"] ~= nil and callProcTable[i]["string_sipDefaultGatewayIpMode"] ~= nil)then
						if(callProcTable[i]["string_sipDefaultGatewayIpPort"] ~= "" and callProcTable[i]["string_sipDefaultGatewayIpAddress"] ~= "" and callProcTable[i]["string_sipDefaultGatewayIpMode"] ~= "")then
							newHost={}
							key=callProcTable[i]["string_sipDefaultGatewayIpPort"]..callProcTable[i]["string_sipDefaultGatewayIpAddress"]..callProcTable[i]["string_sipDefaultGatewayIpMode"]

							newHost["port"]=callProcTable[i]["string_sipDefaultGatewayIpPort"]
							newHost["address"]=callProcTable[i]["string_sipDefaultGatewayIpAddress"]
							newHost["proto"]=callProcTable[i]["string_sipDefaultGatewayIpMode"]:upper()
							newHost["dsc"]=callProcTable[i].string_Description
							newHost["status"]=callProcTable[i].string_disabled
							if(list[key] == nil)then
								list[key]=newHost
							end

							if(callProcTable[i].struct_sipFallback ~= nil)then
								local fb=callProcTable[i].struct_sipFallback
								if(fb.string_IpAddress ~= nil and fb.string_IpMode ~= nil and fb.string_IpPort ~=nil)then
									--printJs("################ FBACK" ..fb.string_IpAddress)
									fkey=fb.string_IpPort..fb.string_IpAddress..fb.string_IpMode
									fallBackHost={}
									fallBackHost.port=fb.string_IpPort
									fallBackHost.address=fb.string_IpAddress
									fallBackHost.proto=fb.string_IpMode
 									fallBackHost.dsc=fb.string_Description
									fallBackHost.status=fb.string_disabled
									if(list[fkey] == nil)then
										list[fkey]=fallBackHost
									end
								end
							end
		    		 		i=i+1	
						end
					end
			    end
				else
					if(callProcTable.string_Destination == "SIP" and callProcTable["string_sipDefaultGatewayIpPort"] ~= nil and callProcTable["string_sipDefaultGatewayIpAddress"] ~= nil and callProcTable["string_sipDefaultGatewayIpMode"] ~= nil)then
						if(callProcTable["string_sipDefaultGatewayIpPort"] ~= "" and callProcTable["string_sipDefaultGatewayIpAddress"] ~= "" and callProcTable["string_sipDefaultGatewayIpMode"] ~= "")then
							newHost={}
							key=callProcTable["string_sipDefaultGatewayIpPort"]..callProcTable["string_sipDefaultGatewayIpAddress"]..callProcTable["string_sipDefaultGatewayIpMode"]

							newHost["port"]=callProcTable["string_sipDefaultGatewayIpPort"]
							newHost["address"]=callProcTable["string_sipDefaultGatewayIpAddress"]
							newHost["proto"]=callProcTable["string_sipDefaultGatewayIpMode"]:upper()
							newHost["dsc"]=callProcTable.string_Description
							newHost["status"]=callProcTable.string_disabled
							if(list[key] == nil)then
								list[key]=newHost
							end

							if( callProcTable[i] and callProcTable[i]["struct_sipFallback"] ~= nil)then
								local fb=callProcTable[i].struct_sipFallback
								if(fb.string_IpAddress ~= nil and fb.string_IpMode ~= nil and fb.string_IpPort ~=nil)then
									printJs("################ FBACK" ..fb.string_IpAddress)
									fkey=fb.string_IpPort..fb.string_IpAddress..fb.string_IpMode
									fallBackHost={}
									fallBackHost.port=fb.string_IpPort
									fallBackHost.address=fb.string_IpAddress
									fallBackHost.proto=fb.string_IpMode
                                    fallBackHost.dsc=fb.string_Description
									fallBackHost.status=fb.string_disabled
				
									if(list[fkey] == nil)then
										list[fkey]=fallBackHost
									end
								end
							end

						end
					end

				end


			end
		end
	end	--end for structGateParams
	end --if table
	local c=1
	local uniqueHosts={}
	for m,n in pairs(list)do
		uniqueHosts[c]=n
		c=c+1
	end
	return uniqueHosts
end

function scan(address, port, proto)
	--get the rand num vom ajax call
	local seeed = request_param("_") or os.time()
	local i
	local resolvedHosts
	local disablePing = request_param("disablePing")
	local results={}
	if(proto:upper() == "UDP") then
	 	results["portProbe"]=udpProbe(address,port,disablePing)
	else
		results["portProbe"]=tcpProbe(address,port,disablePing)
	end
	if(string.find(results["portProbe"],"open") ~= nil )then
		results["optionsPing"]=advancedHostCheck(address,port,proto,"options",seeed)
	end
	return results
end

function getResolvedHosts(address)
	local table={}		
--[[	resolvedHosts=resolveMoreAddresses(address,port,proto)
	for k,v in pairs(resolvedHosts)do
		table[k]={}
		table[k]["address"]=v
		table[k]["results"]={}
	end
	return table
]]--
for k,v in pairs (stdout2table("omggetaddrinfo "..address.." 2>&1"))do
	--print("###"..v)
	if (string.find(v,"Name or service not known") == nil)then
	 table[k]={}
     table[k]["address"]=v
     table[k]["results"]={}
 end
end
	return table
end

local hosts={}
if(request_param("host") ~= nil and request_param("port") ~= nil and request_param("proto") ~= nil )then
	_address=request_param("host")
	_port=request_param("port")
	_proto=request_param("proto")
	_key=_port.._address.._proto
	hosts["address"]=_address
	hosts["results"]=scan(_address, _port, _proto)
	hosts["parent"]=request_param("parent")
	hosts["children"]=getResolvedHosts(_address)		--fill children array
	for k,v in pairs(hosts["children"])do
		v["results"]=scan(v["address"], _port, _proto)
	end
	printJs(hosts)
else

	hosts=getHostsFromConfig()	--returns a key value table


	if(request_param("scan") ~= "false" )then
		for key,target in pairs(hosts)do
			_port=target["port"]
			_proto=target["proto"]
			hosts[key]["children"]=getResolvedHosts(target["address"])		--fill children array
			hosts[key]["results"]=scan(target["address"],_port,_proto)

			print("\n\n\nhost: "..target["address"])
			print("\tprobe:"..target["results"]["portProbe"])

			for u,w in pairs(target["children"])do
				w["results"]=scan(w["address"],_port,_proto)		--scan the child with parents port and proto
				print("\t\tscanning :"..w["address"].."\t\t\t\t result: "..w["results"]["portProbe"])
			end
		end
	end

returnTable={}
returnTable.channelInfo=info
returnTable.hosts=hosts
returnTable.dns={}
returnTable.string_SipBindPort = config.struct_Box.string_SipBindPort

returnTable.localCert=os.captureN('[ -e /data/cert.pem ] && openssl x509 -in /data/cert.pem -noout -enddate | awk -F "=" \'{print $2}\' | awk -F " " \'{print $1" "$2" "$4" "$5}\' || echo No Cert found!')
returnTable.bool_VoipEchoCanceller=bool_VoipEchoCanceller
returnTable.dns.port=config.struct_Box.string_SyslogPort
if(config.struct_Box.string_SyslogDestination == "0.0.0.0")then
	returnTable.dns.address=""
	else
	returnTable.dns.address=config.struct_Box.string_SyslogDestination
end

if(config.struct_Box.string_SyslogProtocol ~= nil) then
    returnTable.dns.proto=config.struct_Box.string_SyslogProtocol:upper()
end

printJs(returnTable)
end




