function resolveMoreAddresses(host, checkPort, checkProto)
	--will return a string (reversed name)
	--or a single address
	--or a table of addresses
	local returnTable={}
	local resolvedHosts={}
    if(host:match("(%d+.%d+.%d+.%d+)") ~= nil) then
	    ipRet=stdout2table('nslookup -q=any '..host..' | grep "name =" | awk -F"= " \'{print $2}\'')
		for k,v in pairs(ipRet) do
			resolvedHosts[table.getn(resolvedHosts)+1]=string.gsub(v,".$","")
		end
	else
		cmd='nslookup -q=any '..host..' | grep -v ^Name: | grep -v ^Server:'
		ret=stdout2table(cmd)	--ret can have many lines, first clear output
		for k,v in pairs(ret)do
			--print("nslookup out: "..v)
			if(string.match(v,"^Address:.*.#") == nil)then
				if(string.match(v,"^Address: "))then			--finds ipv4 addresses in output	
					resolvedHosts[table.getn(resolvedHosts)+1]=Split(v,"Address: ")[2]
				end
				if(string.match(v,"has AAAA address"))then		--finds ipv6 addresses in output
					resolvedHosts[table.getn(resolvedHosts)+1]=Split(v,"has AAAA address ")[2]
				end
			end
			if(string.match(v,"canonical name =") ~= nil)then
				local cname=string.gsub(Split(v,"= ")[2],".$","")
				resolvedHosts[table.getn(resolvedHosts)+1]=resolveMoreAddresses(cname,"null","null")[1]	
			end
		end
    end	--end if(host match ip)
	--print("looked up host: "..host.."  found "..table.getn(resolvedHosts).." returning: ")
	return resolvedHosts
end

function udpProbe(host,port,disablePing)
	local cmd
	local options=""
	if(disablePing == "true")then
		options=options.."-PN"
	end
	if(string.match(host,":") ~= nil) then
		cmd="LC_ALL=C /usr/bin/sudo /usr/bin/nmap "..options.." -6 -sU "..host.." -p "..port.." 2>/dev/null | grep ^"..port.."/udp"
	else
		cmd="LC_ALL=C /usr/bin/sudo /usr/bin/nmap "..options.." -sU "..host.." -p "..port.." 2>/dev/null | grep ^"..port.."/udp"
	end
	local ret=os.captureN(cmd)
	if(string.len(ret) ~= 0)then
		return(Split(ret," ")[2])	
	else
		return "Host unreachable"
	end
end
function tcpProbe(host,port,disablePing)	
	local options=""
	local cmd
	if(disablePing == "true")then
		options=options.."-PN"
	end
	if(string.match(host,":") ~= nil) then
		cmd="LC_ALL=C /usr/bin/sudo /usr/bin/nmap "..options.." -sT  -6 "..host.." -p "..port.." 2>/dev/null | grep ^"..port.."/tcp"
	else
		cmd="LC_ALL=C /usr/bin/sudo /usr/bin/nmap "..options.." -sT  "..host.." -p "..port.." 2>/dev/null | grep ^"..port.."/tcp"
	end

	local ret=os.captureN(cmd)
	if(string.len(ret) ~= 0)then
		return(Split(ret," ")[2])	
	else
		return "Host unreachable"
	end
end
function dnsResolv(host)
	local ret
	if(host:match("(%d+.%d+.%d+.%d+)") ~= nil) then		--got IP doing reverse lookup
		ret=os.captureN('/usr/bin/dig -x '..host..' +short')
	else
		ret=os.captureN('/usr/bin/dig '..host..' +short')	--got hostName? doing normal lookup
	end
	return(ret)	--ret can be an empty string!
end




function trim(s)
  return (s:gsub("^%s*(.-)%s*$", "%1"))
end
function exists(filename)
	local file = io.open(filename)
	if file then
	    io.close(file)
	    return true
    else
        return false
    end
end
function listFiles (path)
    local files={}
    local i=0
        for file in lfs.dir(path) do
            if file ~= "." and file ~= ".." then
                local f = path..'/'..file
                files[i]=f
                i=i+1
            end
    end
    return (files)
end
function parseBchannelFile(v)
        f = io.open (v)
        if f then
                for line in f:lines() do
                        options = SplitCommandlineString(line)_, _, D, B = string.find(options["bchannel"],"(.-)/(.-)/")
                        print (json.encode({
                                dchan=D,
                                bchan=B,
                                date=string.gsub(options["date"],':','\:'),
                                called_party_number=string.gsub(options["called-party-number"], ':', '\:'),
                                calling_party_number=string.gsub(options["calling-party-number"], ":", '\:'),
                                csid=options["csid"],
                                error=options["error"],
                                type=options["type"],
                                bps=options["bps"],
                                ecm=options["ecm"],
                                res=options["res"],
                                t4=options["t4"],
                                txp=options["txp"],
                                rxp=options["rxp"]
                        }))
                        print(",")
                end
        f:close()
        end
end
function mydump(file)
	local f
	local line

	f  = io.open ("/usr/fb/html/" .. file)
	if f then
		for line in f:lines() do
			print(line)			
		end	
		f:close()	
	end
end

function delete(data)
	os.remove("/usr/fb/html/data/fax/bad/" ..entries[data+2])
end

function myprint(data)
	print("<td>&nbsp;" .. data .. "&nbsp;</td>")
end

function centermyprint(data)
	print('<td><div align="center">&nbsp;' .. data .. '&nbsp;</div></td>')
end

function isPDF(data)
	if string.find(data, '.pdf')~= nil then
	return true
	else return false
	end
end

function fromToSubject(data)
	name=string.format("%s%s",'/data/fax/bad/',string.gsub(data, '.pdf', '.mail'))
	file=io.open(name,"r")
	if file then
		from = file:read("*l")
		from=string.gsub(from, "From: ", "")
		centermyprint(from)
		
		to = file:read("*l")
		to=string.gsub(to, "To: ", "")
		--centermyprint(to)

		subject = file:read("*l")
		subject=string.gsub(subject, "Subject: ", "")
		centermyprint(subject)
	end
	io.close(file)
end

function Month(data)
	monthArray={}
	monthArray[01]=	"January"			   
	monthArray[02]=	"February"			   
	monthArray[03]=	"March"			   
	monthArray[04]=	"April"			   
	monthArray[05]=	"May"			   
	monthArray[06]=	"June"			   
	monthArray[07]=	"July"			   
	monthArray[08]=	"August"			   
	monthArray[09]=	"September"			   
	monthArray[10]=	"October"			   
	monthArray[11]=	"November"			   
	monthArray[12]=	"December"			   
	return monthArray[data]
end

function search(data, position)
		local nBegin, nEnd
		nBegin, nEnd = string.find(data,"%u", position)
		return nBegin
	end

--[[--------------------------------------------------------------
Split jobcontrol command line
--------------------------------------------------------------]]--
function SplitCommandlineString(data, optionsTable, initTable)
    local jcargs = {}

    local count
    local valueStart
    local valueEnd
    local nameStart
    local nameEnd
    local markerFound
    local marker
    local pos

    if initTable ~= nil then
        jcargs = initTable()
    end

    pos = 1
    while 1 do
        valueStart = nil
        valueEnd = nil
        nameStart = nil
        nameEnd = nil

        pos = string.find(data,"-",pos)
        if pos == nil then break end
        if string.sub(data,pos,pos+1) == "--" then
            nameStart = pos+2
            equalSignPos = string.find(data,"=",pos+2)
            if equalSignPos ~= nil then
                nameEnd = equalSignPos-1
                pos = equalSignPos+1
                while 1 do
                    local c = string.sub(data,pos,pos)
                    if (c == nil) or (c == "") then
                        valueEnd = pos-1
                        break
                    elseif (valueStart == nil) and (c == " " or c == "\t") and (markerFound == nil) then
                        pos = pos + 1
                    elseif (valueStart ~= nil) and (c == " " or c == "\t") and (markerFound == nil) then
                        valueEnd = pos-1
                        pos = pos + 1
                        break
                    elseif (c == "\"" or c == "'") and (markerFound == nil) then
                        pos = pos + 1
                        marker = c
                        markerFound = 1
                        valueStart = pos
                    elseif (marker~=nil) and (c == marker) and (markerFound ~= nil) then
                        valueEnd = pos-1
                        pos = pos + 1
                        marker = nil
                        markerFound = nil
                        break
                    elseif valueStart == nil then
                        valueStart = pos
                        pos = pos + 1
                    else
                        pos = pos + 1
                    end
                end
            else
                pos = pos + 1
            end
        else
            nameStart = pos+1
            nameEnd = nameStart
            pos = pos + 2
            while 1 do
                local c = string.sub(data,pos,pos)
                if (c == nil) or (c == "") then
                    if valueStart ~= nil then valueEnd = pos-1 end
                    break
                elseif (valueStart == nil) and (c == " " or c == "\t") and (markerFound == nil) then
                    pos = pos + 1
                elseif (valueStart ~= nil) and (c == " " or c == "\t") and (markerFound == nil) then
                    valueEnd = pos-1
                    pos = pos + 1
                    break
                elseif (c == "\"" or c == "'") and (markerFound == nil) then
                    pos = pos + 1
                    marker = c
                    markerFound = 1
                    valueStart = pos
                elseif (c == "^%S-") and (markerFound == nil) then
                    if valueStart ~= nil then valueEnd = pos-1 end
                    pos = pos - 1
                    break
                elseif (marker~=nil) and (c == marker) and (markerFound ~= nil) then
                    if valueStart ~= nil then valueEnd = pos-1 end
                    pos = pos + 1
                    marker = nil
                    markerFound = nil
                    break
                elseif (valueStart == nil) and (c == " " or c == "\t") and (markerFound == nil) then
                    pos = pos + 1
                elseif valueStart == nil then
                    valueStart = pos
                    pos = pos + 1
                else
                    pos = pos + 1
                end
            end
        end
        if (nameStart ~= nil) and (nameEnd ~= nil) and (valueStart ~= nil) and (valueEnd ~= nil) then
            local name = string.sub(data,nameStart,nameEnd)
            if optionsTable ~= nil then
                name = optionsTable[name] or name
            end
            jcargs[name]=string.sub(data,valueStart,valueEnd)
        elseif (nameStart ~= nil) and (nameEnd ~= nil) and (valueStart == nil) and (valueEnd == nil) then
            local name = string.sub(data,nameStart,nameEnd)
            if optionsTable ~= nil then
                name = optionsTable[name] or name
            end
            jcargs[name]="true"
        end
    end
    return jcargs
end


