#!/usr/bin/luaweb
json = require("json")
omg = require("omg")
require("os")

print ("Content-type: application/json\n")
function printJs(str)
    print(json.encode(str))
end


function omg.capture(cmd, raw)
  local f = assert(io.popen(cmd, 'r'))
  local s = assert(f:read('*a'))
  f:close()
  return s
end
function omg.captureN(cmd, raw)
  local f = assert(io.popen(cmd, 'r'))
  local s = assert(f:read('*a'))
  f:close()
  if raw then return s end
      s = string.gsub(s, '^%s+', '')
      s = string.gsub(s, '%s+$', '')
      s = string.gsub(s, '[\n\r]+', ' ')
  return s
end

--
function omg.stdout2table(cmd)
    local myTable={}
    local i=1
    stdout=omg.capture("LC_ALL=C "..cmd,true)
    for line in stdout:gmatch("[^\n\r]+")do
        line = string.gsub(line, '\'', '"')
        myTable[i]=line
        i=i+1
    end
    return myTable
end

--[[--------------------------------------------------------------
Split jobcontrol command line
--------------------------------------------------------------]]--
function SplitCommandlineString(data, optionsTable, initTable)
    local jcargs = {}

    local count
    local valueStart
    local valueEnd
    local nameStart
    local nameEnd
    local markerFound
    local marker
    local pos

    if initTable ~= nil then
        jcargs = initTable()
    end

    pos = 1
    while 1 do
        valueStart = nil
        valueEnd = nil
        nameStart = nil
        nameEnd = nil

        pos = string.find(data,"-",pos)
        if pos == nil then break end
        if string.sub(data,pos,pos+1) == "--" then
            nameStart = pos+2
            equalSignPos = string.find(data,"=",pos+2)
            if equalSignPos ~= nil then
                nameEnd = equalSignPos-1
                pos = equalSignPos+1
                while 1 do
                    local c = string.sub(data,pos,pos)
                    if (c == nil) or (c == "") then
                        valueEnd = pos-1
                        break
                    elseif (valueStart == nil) and (c == " " or c == "\t") and (markerFound == nil) then
                        pos = pos + 1
                    elseif (valueStart ~= nil) and (c == " " or c == "\t") and (markerFound == nil) then
                        valueEnd = pos-1
                        pos = pos + 1
                        break
                    elseif (c == "\"" or c == "'") and (markerFound == nil) then
                        pos = pos + 1
                        marker = c
                        markerFound = 1
                        valueStart = pos
                    elseif (marker~=nil) and (c == marker) and (markerFound ~= nil) then
                        valueEnd = pos-1
                        pos = pos + 1
                        marker = nil
                        markerFound = nil
                        break
                    elseif valueStart == nil then
                        valueStart = pos
                        pos = pos + 1
                    else
                        pos = pos + 1
                    end
                end
            else
                pos = pos + 1
            end
        else
            nameStart = pos+1
            nameEnd = nameStart
            pos = pos + 2
            while 1 do
                local c = string.sub(data,pos,pos)
                if (c == nil) or (c == "") then
                    if valueStart ~= nil then valueEnd = pos-1 end
                    break
                elseif (valueStart == nil) and (c == " " or c == "\t") and (markerFound == nil) then
                    pos = pos + 1
                elseif (valueStart ~= nil) and (c == " " or c == "\t") and (markerFound == nil) then
                    valueEnd = pos-1
                    pos = pos + 1
                    break
                elseif (c == "\"" or c == "'") and (markerFound == nil) then
                    pos = pos + 1
                    marker = c
                    markerFound = 1
                    valueStart = pos
                elseif (c == "^%S-") and (markerFound == nil) then
                    if valueStart ~= nil then valueEnd = pos-1 end
                    pos = pos - 1
                    break
                elseif (marker~=nil) and (c == marker) and (markerFound ~= nil) then
                    if valueStart ~= nil then valueEnd = pos-1 end
                    pos = pos + 1
                    marker = nil
                    markerFound = nil
                    break
                elseif (valueStart == nil) and (c == " " or c == "\t") and (markerFound == nil) then
                    pos = pos + 1
                elseif valueStart == nil then
                    valueStart = pos
                    pos = pos + 1
                else
                    pos = pos + 1
                end
            end
        end
        if (nameStart ~= nil) and (nameEnd ~= nil) and (valueStart ~= nil) and (valueEnd ~= nil) then
            local name = string.sub(data,nameStart,nameEnd)
            if optionsTable ~= nil then
                name = optionsTable[name] or name
            end
            jcargs[name]=string.sub(data,valueStart,valueEnd)
        elseif (nameStart ~= nil) and (nameEnd ~= nil) and (valueStart == nil) and (valueEnd == nil) then
            local name = string.sub(data,nameStart,nameEnd)
            if optionsTable ~= nil then
                name = optionsTable[name] or name
            end
            jcargs[name]="true"
        end
    end
    return jcargs
end


function parseBchannelFile(v)
    f = io.open (v)
    if f then
        for line in f:lines() do
            options = SplitCommandlineString(line)_, _, D, B = string.find(options["bchannel"],"(.-)/(.-)/")
--            return (json.encode({
            	return({
                dchan=D,
                bchan=B,
                date=string.gsub(options["date"],':','\:'),
                called_party_number=string.gsub(options["called-party-number"], ':', '\:'),
                calling_party_number=string.gsub(options["calling-party-number"], ":", '\:'),
                csid=options["csid"],
                error=options["error"],
                type=options["type"],
                bps=options["bps"],
                ecm=options["ecm"],
                res=options["res"],
                t4=options["t4"],
                txp=options["txp"],
                rxp=options["rxp"]
				})
  --         }))
       end
    f:close()
    end
end
function file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f)
       return true
   else
       return false end
end

function split(str, pat)
   local t = {}  -- NOTE: use {n = 0} in Lua-5.0
   local fpat = "(.-)" .. pat
   local last_end = 1
   local s, e, cap = str:find(fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s, e, cap = str:find(fpat, last_end)
   end
   if last_end <= #str then
      cap = str:sub(last_end)
      table.insert(t, cap)
   end
   return t
end
local results={}
local active={}
local dStates=omg.stdout2table("sudo getstates 2>&1")

local bChannels=omg.stdout2table("sudo getchannels -b 2>&1 | grep -v \"B-Channels and \"")
local dChannels=omg.stdout2table("sudo getchannels -d 2>&1 | grep -v \"B-Channels and \"")
--local allChannels = omg.stdout2table("sudo getchannels -d -b 2>&1 | grep -v \"B-Channels and \"")
local options = omg.splitCommandlineString(arg)

for k,chan in ipairs(bChannels)do
	local sp = split(chan,"/")
	local d=sp[1]
	local b=sp[2]
	local t=sp[3]
	local tt=sp[4]
	local fName
	fName = "/tmp/BChannelState-"..d.."-"..b.."-"..t.."-"..tt

	if(file_exists(fName) == true)then
			local parsed = parseBchannelFile(fName)
			if(parsed['error'] == "active" or parsed['error'] == "none")then
				table.insert(active, chan)
			end
	end
end
--printJs(active)

results["resources"]={}
results["resources"]["load"]=omg.captureN("cat /proc/loadavg  | awk -F ' ' '{print $1\" \"$2\" \"$3}'")
results["resources"]["cpus"]=omg.captureN("nproc")
results["resources"]["mem"]=omg.stdout2table('free | grep Mem: | awk -F " " \'{print $2"\\n"$3"\\n"$4"\\n"$5"\\n"$6"\\n"$7}\'')
results["resources"]["memHelp"]="total,used,free,shared,buffers,cached"

results["dstates"]=dStates
results["active"]=active
results["getchannels"]=omg.captureN("sudo getchannels 2>&1")

--if(options.full == true)then
	results['bchannels']=bChannels
	results['dchannels']=dChannels
--end
results["total"]=#bChannels
results["inUse"]=#active
results["summary"]=#active.."/"..#bChannels.." bChannels in use"



--printJs(args)
printJs(results)
--omg.runScript(results,arg,"print version information\n")











