
function shakeHands(conn)
	local succ, msg
	conn:settimeout(8,t)
	succ, msg = conn:dohandshake()
 	return succ,msg
end
	
function readAll(msg)
	file = "contents/sipmsg-"..msg
    local f = io.open(file, "rb")
    local content = f:read("*all")
    f:close()
    return content
end

function isIpAddress(ip)
	if not ip then return false end
	local a,b,c,d=ip:match("^(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)$")
	a=tonumber(a)
	b=tonumber(b)
	c=tonumber(c)
	d=tonumber(d)
	if not a or not b or not c or not d then return false end
	if a<0 or 255<a then return false end
	if b<0 or 255<b then return false end
	if c<0 or 255<c then return false end
	if d<0 or 255<d then return false end
	return true
end

function prepareSipMSG(MSG, loPort, loAddress, mode,remAddress,port,seeed)	
	seeed = seeed or os.time()
	local contentRemAddress,contentLoAddress
	if(string.find(remAddress,":") ~= nil)then	
		contentRemAddress="["..remAddress.."]"
	else
		contentRemAddress=remAddress
	end
	if(string.find(loAddress,":") ~= nil)then
		contentLoAddress="["..loAddress.."]"
	else
		contentLoAddress=loAddress
	end
	--when running from console - we don't have an ajax seeed! But the calls are synchronous then!
	math.randomseed(seeed)
	numrand=math.random(10000,160000)
--	Cseq=string.sub(numrand,0,3)
--	callId="1"..string.sub(numrand,1,5)
	Cseq=numrand
	callId="1"..numrand

	
	content=readAll(MSG)
	content=content.gsub(content,"XXXloPortXXX",loPort)
	content=content.gsub(content,"XXXloAddressXXX",contentLoAddress)
	content=content.gsub(content,"XXXProtoXXX",mode:upper())
	content=content.gsub(content,"XXXRemAddressXXX",contentRemAddress)
	content=content.gsub(content,"XXXPortXXX",port)
	content=content.gsub(content,"XXXCallIDXXX",callId)
	content=content.gsub(content,"XXXCseqXXX",Cseq)
	return content
end

--function checkCer(host,)



function advancedHostCheck(host,port,mode,check,seeed)
	local content=""
	results={
		tcp=false,
		udp=false,
		tls=false,
		handshake=false,
		err="",
		sipresult=false,
		sipmsg="",
		expiry=""
	}
	if(mode:upper() == "TLS")then
		local remAddress = host
		local origHost = host
		if(isIpAddress(host) ~= true and string.find(remAddress,":") == nil)then
			remAddress=(socket.dns.toip(host))
			host=ip
		end
		if(string.find(remAddress,":") ~= nil)then
			remAddress=host
		end
		local conn,connection
		if(string.find(remAddress,":") == nil)then
			conn = socket.tcp()					--get a sock
		else
			conn = socket.tcp6()					--get a sock
		end
		connection=conn:connect(remAddress, port) 	--establish tcp connection
		conn:settimeout(9)
		if(connection ~= nil)then	--tcp connection established
			local loAddress,loPort=conn:getsockname()
			results["tls"]=true	
			content = prepareSipMSG("OPTIONS",loPort,loAddress,mode,remAddress,port,seeed)
			sslCheck(conn, check, content)
		else
			results["tls"]=false
			results["err"]="FAILED to establish TCP Connection with "..origHost.." on port:"..port
		end
		conn:close()
	end	--end of TLS check


	if(mode:upper() == "TCP")then
		local remAddress = host
		if(isIpAddress(host) ~= true and string.find(host,":") == nil)then
			remAddress=(socket.dns.toip(host))
			if(remAddress ~= nil)then
				host=remAddress
			else
				results["tcp"]=false
				results["err"]="Could not resolve Hostname to valid address"
				os.exit(1)
			end
		end
		local conn,connection

		if(string.find(remAddress,":") == nil)then
			conn = socket.tcp()					--get a sock
		else
			conn = socket.tcp6()					--get a sock
		end
		connection=conn:connect(remAddress, port) 	--establish tcp connection
		local loAddress,loPort=conn:getsockname()
		conn:settimeout(8)
		if(connection ~= nil)then	--tcp connection established
			results["tcp"]=true
			content = prepareSipMSG("OPTIONS",loPort,loAddress,mode,remAddress,port,seeed)
			tcpCheck(conn, check, content,remAddress,seeed)
			conn:close()
		else
			
			results["tcp"]=false
			results["err"]="FAILED to establish TCP Connection with "..host.." on port:"..port
		end
	end	--end of TCP check


	if(mode:upper() == "UDP")then
		--xxx
		local remAddress = host
		if(isIpAddress(host) ~= true)then
			remAddress=(socket.dns.toip(host))
			host=ip
		end
		local udp,err
		if(string.find(remAddress,":") == nil)then
			udp,err = socket.udp()
		else
			udp,err = socket.udp6()
		end
		udp:settimeout(2)
		udp:setsockname("*",0)
		udp:setpeername(remAddress, port)
		loAddress, loPort = udp:getsockname()
		print("using local: "..loAddress, loPort)
		content = prepareSipMSG("OPTIONS",loPort,loAddress,mode,remAddress,port,seeed)
		udp:send(content)
		local line, err = udp:receive()
	    if(line ~= nil and string.find(line,"SIP/2.0 200 OK") ~= nil)then
            results.sipresult=true
            results.sipmsg="SIP/2.0 200 OK"
		else	
            results.sipmsg="No Data"
        end
		udp:close()
	end	--end of UDP check
	
	return results
end




function tcpCheck(conn,check,content,remAddress,seeed)
	conn:send(content)
	local line, err = conn:receive()
	if(line ~= nil)then
		if(string.find(line,"200 OK") ~= nil)then
			results.sipresult=true
			results.sipmsg=line
		end
	else
		results.sipmsg="No Data"
	end
	if(err == "wantread")then
		results["err"]="The operation is not finished because a timeout in the underline TCP connection prevents it of sending data."
	end
end















function sslCheck(conn,check,content)	
	params = {	
		mode = "client",
		protocol = "sslv3",
		key = "/data/key.pem",
		certificate = "/data/cert.pem",
		cafile = "/data/ca.pem",
	    verify = {"peer", "fail_if_no_peer_cert"},
	    options = {"all"},
	}
	conn:settimeout(5)
	conn,err = ssl.wrap(conn, params)
	if(conn ~= nil)then
		handShake,msg=shakeHands(conn)
		if(handShake ~= false)then	
			results["handshake"]=true
			cert = conn:getpeercertificate()
			local time = os.time;

            if not cert:valid_at(os.time()+86400*7) then
 	 	     	results["expiry"]="<span style='color:red'>(expires this week)</span>";
            elseif not cert:valid_at(os.time()+86400*30) then
                results["expiry"]="<span style='color:red'>(expires this month)</span>";
     	  	elseif not cert:valid_at(os.time()+86400*30*2) then
                results["expiry"]="<span style='color:red'>(expires next month)</span>";
            end
		if(check == "options")then
				conn:send(content)
				local line, err = conn:receive()
				if(line ~= nil and string.find(line,"200 OK") ~= nil)then
					results.sipresult=true
					results.sipmsg=line
				end
				if(err == "wantread")then
					results["err"]="The operation is not finished because a timeout in the underline TCP connection prevents it of sending data."
				end
				if(err ~= nil)then
					results.sipmsg="No Data"
				end
			end	--end of if "options"
		else
			results["handshake"]=false
			results["err"]="FAILED to perform TLS/SSL Handshake reason:"..msg
		end
	else
		results["handshake"]=false
		results["err"]="FAILED to established secure session"
	end
end
