#!/bin/bash

mode=$1
iface=$2

rm -f /tmp/logs/capture.cap

if [ ! -e /tmp/logs ] ; then mkdir /tmp/logs/ ;fi

pidfile=/var/run/startcapture.pid

mymacaddr=$(LC_ALL=C ifconfig ${iface} | grep -i HWaddr | awk -F "HWaddr " '{ print $2}')

SNAPLEN="-s 0"


if [ -e "$pidfile" ];then 				#if there is a pidfile check its content
	oldpid=$(cat $pidfile)
	if [ "$(grep -q tcpdump /proc/${oldpid}/cmdline 2>&1 >/dev/null; echo $?)" == 0 ]; then 			#if the pid found in pidfile exists in proc and contains tcpdump, exit 1	
		echo "retval: 1"
		exit 1
	else	
		rm $pidfile
	fi
fi


if [ "$mode" == "local" ];then
	DEVICE="lo"
	FILTER=" not port 514 and not port 22"
fi
if [ "$mode" == "remote" ];then 
	
#	FILTER=" ether host $mymacaddr and ((portrange 3215-3229 or portrange 5060-5069) and (udp or tcp) and not port 514)"
	FILTER=" ether host $mymacaddr and not port 514 and not port 22"
	DEVICE="${iface}"
fi



nohup tcpdump -a -U -i $DEVICE -w /tmp/logs/capture.cap -p -n  ${SNAPLEN} ${FILTER} < /dev/null >/dev/null 2>/dev/null &

pid=$!
echo "${pid}" > $pidfile

echo "started" > /tmp/cap