function categorySort(selector){
	var mylist = $(selector);
	var listitems = mylist.children('li').get();
	listitems.sort(function(a, b) {
	   var compA = $(a).text().toUpperCase();
	   var compB = $(b).text().toUpperCase();
	   
	   return compA>compB
	})
	$.each(listitems, function(idx, itm) {
		mylist.append(itm);
	});
}
function loadLog(name,logTimer,category,subCategory){
	$(".ajaxLog").html('<img alt="loader" src="/images/ajax-loader.gif"/>');
	numRand = Math.floor(Math.random()*101)
	$.ajax({
		url: "/cgi-bin/getLog.lua",
		processData:true,
		data: { name: name,
				numRand:numRand
			},
		dataType: "json",
		success: function(json) {
			var element = $(document.createElement('div'));
			element.addClass("logContent");
			$(".logContent").empty();
			$.each(json.log,function(i, data){
				element.append("<pre>"+data.line+"</pre>");
				search="++++++++++++++++++++++ test " + name;
				if(data.line.indexOf(search) != -1){
					if(logTimer != null){
						clearInterval(logTimer);
						update(category,subCategory,name);
					}
						$(".ajaxLog").empty();
					
				}
			});
			
			
			
			$(".logContent").html(element);
			
			highLightElements=$(".logContent").find("pre");
			markBadWords(highLightElements,"badWord",pageData.badWords);
			markBadWords(highLightElements,"goodWord",pageData.goodWords);
			markBadWords(highLightElements,"importantWord",pageData.importantWords);
			
			
		},
		error: function(x,y,z) {
			//throw error if needed, and tell what happened
			//console.log(x.responseText);
			console.log(x.status);
            //console.log(x.responseText+"\n"+z);
		}
	});
	
}




function colorize(){	
	//find all failed items and mark the Tabs
	elements=$(".row.td[state=unknown]");
	$.each(elements,function(i,elem){
		category=$(this).attr("category");
		subCategory=$(this).attr("subCategory");
		$("li a[href=#"+category+"_"+subCategory+"]").css("background-color","#F2F5A9");
		$("li a[href=#category_"+category+"]").css("background-color","#F2F5A9");
	});
	elements=$(".row.td[state=fail]");
	$.each(elements,function(i,elem){
		category=$(this).attr("category");
		subCategory=$(this).attr("subCategory");
		$("li a[href=#"+category+"_"+subCategory+"]").css("background-color","#F6CED8");
		$("li a[href=#category_"+category+"]").css("background-color","#F6CED8");
	});
}



function update(category,subcategory,name){
	showRefreshing(category,subCategory,name);
	
	var timer = setInterval(function(){
		$.getJSON("cgi-bin/getTestData3.lua",{ name: name, method: "partial"}, function(data) {
			$.each(data.tests,function(index,data){
					$.each(this,function(index,data){
						$.each(this,function(index,data){
							id=name.replace(/\./g,"_");
							$("#"+id).replaceWith(' \
									<div class="row td" state='+data.status+' style="width:100%" category="'+category+'" subCategory="'+subCategory+'" id="'+id+'"> \
									<div class="cell name">'+index+'</div> \
									<div class="cell status '+data.status+'">'+data.status+'</div> \
									<div class="cell category"><nobr>'+data.testCategory+'</nobr></div> \
									<div class="cell description"><div style="float:left">'+data.description+'</div></div>	\
									<div class="cell"><button class="sexybutton" id="action" name="'+index+'" category="'+category+'" subCategory="'+subCategory+'"><span><span><span class="play">start</span></span></span></button></div> \
									<div class="cell"><button class="sexybutton" id="refresh" name="'+index+'" category="'+category+'" subCategory="'+subCategory+'"><span><span><span class="reload">refresh</span></span></span></button></div> \
									<div class="cell"><button class="sexybutton" id="log" name="'+index+'"><span><span><span class="paste">log</span></span></span></button></div> \
								</div>');
					});
				});
			});
			clearInterval(timer)
			colorize();		
		});
	},1000);
}


function showRefreshing(category,subCategory,name){
	id=name.replace(/\./g,"_");
	$("#"+id).replaceWith(' \
			<div class="row td" state="unknown" style="width:100%" category="'+category+'" subCategory="'+subCategory+'" id="'+id+'"> \
			<div class="cell name">'+name+'</div> \
			<div class="cell status unknown"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
			<div class="cell category"><img alt="loader" src="/images/ajax-loader.gif"/></div> \
			<div class="cell description"><div style="float:left"><img alt="loader" src="/images/ajax-loader.gif"/></div></div>	\
			<div class="cell"><button class="sexybutton" id="action" name="'+name+'"><span><span><span class="play">start</span></span></span></button></div> \
			<div class="cell"><button class="sexybutton" id="refresh" name="'+name+'" category="'+category+'" subCategory="'+subCategory+'"><span><span><span class="reload">refresh</span></span></span></button></div> \
			<div class="cell"><button class="sexybutton" id="log" name="'+name+'"><span><span><span class="paste">log</span></span></span></button></div> \
		</div>');
}


function subCategoryContent(category,subCategory,obj){
	$("#"+ category + "_" +subCategory).append(' \
			<div class="subMenu"> \
				 \
			</div> \
			<div style="clear:both"/>');
	$("#"+ category + "_" +subCategory).append(' \
		<div class="table sippTests">	\
			<div class="row sippTeststh" id="th"> \
				<div class="thcell name">Name</div> \
				<div class="thcell status">Status</div> \
				<div class="thcell description">Description</div> \
				<div class="thcell actions"></div>\
			 	<div class="thcell actions"><button class="sexybutton" id="test_subGroup" category="'+category+'" subCategory="'+subCategory+'" name="asd" style="float:right"><span><span><span class="play">Start '+category+'.'+subCategory+'.*</span></span></span> </button></div> \
			 	<div class="thcell actions"><button class="sexybutton" id="refresh_subGroup" category="'+category+'" subCategory="'+subCategory+'" name="asd" style="float:right"><span><span><span class="reload">Refresh '+category+'.'+subCategory+'.*</span></span></span></button></div>\
			 	<div class="thcell actions"></div>\
		    </div>\
		    <div class="tbody"></div> \
	   </div>');

	$.each(obj, function(index, value) {
			$("#"+ category + "_" +subCategory +" .table .tbody").append(' \
						<div class="row td" state='+value.status+' style="width:100%" category="'+category+'" subCategory="'+subCategory+'" id="'+index.replace(/\./g,"_")+'"> \
							<div class="cell name">'+index+'</div> \
							<div class="cell status '+value.status+'">'+value.status+'</div> \
							<div class="cell status '+value.testCategory+'">'+value.testCategory+'</div> \
							<div class="cell description"><div style="float:left">'+value.description+'</div></div>	\
							<div class="cell"><button class="sexybutton" id="action" name="'+index+'"><span><span><span class="play">start</span></span></span></button></div> \
							<div class="cell"><button class="sexybutton" id="refresh" name="'+index+'" category="'+category+'" subCategory="'+subCategory+'"><span><span><span class="reload">refresh</span></span></span></button></div> \
							<div class="cell"><button class="sexybutton" id="log" name="'+index+'"><span><span><span class="paste">log</span></span></span></button></div> \
						</div>');
			
	});
	
	
}
function subCategories(category,obj){
	
	$.each(obj,function(subCategory,obj){
			$(".category_" + category +"_tab").append("<li><a href='#"+category +"_"+subCategory+"'>"+subCategory+"</a></li>"); 
			$(".subtabs_"+category).append("<div class='ui-tabs-panel ui-widget-content ui-corner-bottom ui-tabs-hide' id='"+category +"_" + subCategory +"'>");
			subCategoryContent(category,subCategory,obj)
			$(".subtabs_"+category).append("</div>"); 	
		
	});
	$(".category_" + category + "_tab").tabs();
	$(".subtabs_"+category).tabs();

}


function fillTable(data){
	count=0;
	$.each(data.tests,function(category,obj){
		count=count+1;
		//adds the main ul/li navigation -Tabs
		//adds divs with id="category" and also adds ul/li navigation tabs for subTabs
		$(".tabNavigation").append("<li><a href='#category_"+ category + "'>"+category+"</a></li>");
		$(".tabs").append("<div class='ui-tabs-panel ui-widget-content ui-corner-bottom ui-tabs-hide' id='category_"+ category +"'> \
				<div class='subtabs_"+category+"'> \
					<ul class='category_" +category+ "_tab'></ul> \
				</div> \
		</div>");
	
		subCategories(category,obj)
		categorySort('.category_'+category+'_tab')
	});
	if(count != 0){
		$(".tabs").tabs();
		categorySort(".tabNavigation");
		colorize();
	}else{
		$("noTabs").html('<h1>No Sip<i>p</i> tests found, check your installation!</h1>')
	}
}



