#!/bin/bash 
trap 'trap_handler' QUIT TERM INT SIGINT 0 1 2 3 9 11 13 15
start=1000
end=3300
channels=30
startport=6062
rtpstartport=1024
callingPartyNumber="\#9"
#callingPartyNumber=
good=logs/pbx.list.log
bad=logs/400.list.log

rm -fr logs ; mkdir -p logs


children=0  #dont touch me!

before=$(date +%s)
number=${start} 
sippport=${startport}
rtpport=${rtpstartport}
iface=$(LC_ALL=C route -n | grep 0.0.0.0 | grep UG | awk -F " " '{print $8}')
[ -z ${iface} ] && iface=eth0
IP=$(LC_ALL=C ifconfig $iface | grep inet\ addr | awk -F ":" '{print $2}' | sed s/\ .*//g)

count=$((${end}-${start}+1))
echo "gesamt: ${count}"

function trap_handler(){
			echo "trap handler called"
			echo Waiting for remaining sipps to finish
			number=${end}
			remaining=$(ps fax | grep sipp\ 127.0.0.1:5060|grep -v grep | awk -F " " '{print $1}')
			for i in $remaining;do 
				while [ $(kill -s 0 ${i} 2>/dev/null; echo $?) -ne 1 ];do
					echo -n .
					sleep 1
				done
			done
}


    while [ true ];do	

		children=$(ps fax | grep -v grep | grep -c "sipp 127.0.0.1")
		[ $children -gt ${channels} ] && echo CHILDREN TO BIIIIGGG!!! $children && exit 3

        if [ ${children} -lt ${channels} ]; then 
            if [ ${number} -le ${end} ]; then
                echo "======calling from port:$sippport with rtpport:$rtpport to number: $number"
                cmd() { 
					netstat -an | grep LISTEN | grep :${sippport}; ret=$?
					if [ $ret -eq 0 ];then echo "sipport : ${rtpport} is in use!!"; exit 3;fi
					netstat -an | grep LISTEN | grep :${rtpport}
					if [ $? -eq 0 ]; then echo "rtpport : ${rtpport} is in use!!"; exit 4;fi

					#-trace_dtmf -trace_logs  -rtp_receive -rtp_echo -trace_shortmsg -trace_msg -trace_err 
					sipp 127.0.0.1:5060 -sf bruteCall.xml -mp ${rtpport}  -p ${sippport} -set callingPartyNumber ${callingPartyNumber} 	-silent -t tn -i ${IP} -mi ${IP} -pause_msg_ign -m 1 -s ${number} \
					 -trace_dtmf -trace_logs  -rtp_receive -rtp_echo -trace_shortmsg -trace_msg -trace_err  2>&1 > logs/log_${number}.log 2>&1
					ret=$?
				    [ $ret -eq 0 ] && echo ${number} >> ${good}
				    [ $ret -ne 0 ] && echo ${number} >> ${bad}
			    }
                cmd &
				if [ ${sippport} -gt $((${startport}+$((${channels}*20)))) ];then		#10mal so viele ports wie channels offen sein koennen, dann vorne beginnen
					echo "############################################# port was: ${sippport}  -> start at beginning: ${startport}"
					sippport=${startport}
				fi
				if [ ${rtpport} -gt $((${rtpport}+$((${channels}*50)))) ];then
					echo "############################################# RRRTTTPP port was: ${rtpport}  -> start at beginning: ${rtpstartport}"
					rtpport=${rtpstartport}
				fi

				rtpport=$((${rtpport}+4))
				sippport=$((${sippport}+1))
        	    number=$((${number}+1))
				children=$(ps fax | grep -v grep | grep -c "sipp 127.0.0.1")
				[ $children -gt ${channels} ] && echo CHILDREN TO BIIIIGGG!!! $children && exit 3


        else	#end of numbers
            echo "ALL DONE!" # num>end
			grep -Hirn bind logs/

			echo Waiting for remaining sipps to finish
			remaining=$(ps fax | grep sipp\ 127.0.0.1:5060|grep -v grep | awk -F " " '{print $1}')
			for i in $remaining;do 
				while [ $(kill -s 0 ${i} 2>/dev/null; echo $?) -ne 1 ];do
					echo -n .
					sleep 1
				done
			done
			after=$(date +%s)
			echo
			echo "completed: ${count} tests on $channels channels"
			echo "elapsed time:" $((after - $before)) "seconds"
            exit 0
       fi	# end of number < end if
	

	else #children >= channels
		children=$(ps fax | grep -v grep | grep -c "sipp 127.0.0.1")
		[ $children -gt ${channels} ] && echo CHILDREN TO BIIIIGGG!!! $children && exit 3
#		echo "$? == no free channels now running : ${children}== "
          sleep 0.2
   fi
   done
